#include <avr/io.h>             // AVR device-specific IO definitions
#include <avr/interrupt.h>	    // Interrupt Service routine
#define F_CPU 8000000UL         // 8 MHz
#include <util/delay.h>         // header file implement simple delay loops
#include<compat/deprecated.h>	//use sbi,cbi
#include<stdio.h>

#define Vadc 1024		// 1024 (10-bit Resolution)

unsigned int adc,a=0,r,g,b;
long int c=0;
/*********** delay *************/
void delay_ms(unsigned int i)
{
	for(;i>0;i--)
	_delay_ms(1);
}
/********adc==0***********/
void zero()
{
		if(a==1){
		OCR0 = 70;
		OCR1A = 1;
		OCR2 = 220;
		delay_ms(1000);
		}
		if(a==2){
		OCR0 = 1;
		OCR1A = 1;
		OCR2 = 200;
		delay_ms(1000);
		}
		if(a==3){
		OCR0 = 1;
		OCR1A = 200;
		OCR2 = 120;
		delay_ms(1000);
		}
		if(a==4){
		OCR0 = 1;
		OCR1A = 200;
		OCR2 = 1;
		delay_ms(1000);
		}
		if(a==5){
		OCR0 = 113;
		OCR1A = 182;
		OCR2 = 1;
		delay_ms(1000);
		}
		if(a==6){
		OCR0 = 200;
		OCR1A = 80;
		OCR2 = 1;
		delay_ms(1000);
		}
		if(a==7){
		OCR0 = 200;
		OCR1A = 1;
		OCR2 = 1;
		delay_ms(1000);
		}
		if(a==8){
		OCR0 = 150;
		OCR1A = 60;
		OCR2 = 90;
		a=0;
		delay_ms(1000);
		}
		
		}
		


/************************************/
int main(void)
{
	
	DDRA = (0<<DDA0);
	DDRB = (1<<DDB3);
	DDRD = (1<<DDD5)|(1<<DDD7);

/******************** Timer0 ************************/
	TCCR0=(0<<CS02)|(1<<CS01)|(0<<CS00);	//prescale 
	TCCR0 |= (1<<WGM01)|(1<<WGM00);         // Fast PWM
    TCCR0 |= (1<<COM01)|(0<<COM00);         // Clear OC0 on compare match,Set OC0 at TOP
    
/******************** Timer2 ****************************/
	TCCR2=(0<<CS22)|(1<<CS21)|(0<<CS20);	//prescale 
	TCCR2 |= (1<<WGM21)|(1<<WGM20);         // Fast PWM
    TCCR2 |= (1<<COM21)|(0<<COM20);         // Clear OC0 on compare match,Set OC0 at TOP
     
/******************** Timer1 ***************************/
	TCCR1A 	= (1<<COM1A1)|(0<<COM1A0)|(1<<COM1B1)|(0<<COM1B0);
	TCCR1B  = (0<<WGM13)|(1<<WGM12);    
    TCCR1A |= (0<<WGM11)|(1<<WGM10); 

	TCCR1B |= (0<<CS12)|(1<<CS11)|(0<<CS10);

   	TIMSK = (1<<TOIE0)|(1<<TOIE2)|(1<<TOIE1);   // T/C0 Overflow interrupt Enable
    sei();                                 		// Set I-bit global interrupt enable
/**********************************************************/
/********************** a2d ********************************/
// AVCC with external capacitor at AREF pin
	ADMUX = (0<<REFS1)|(1<<REFS0);

// ADC Enable & Auto Trigger Disable
	ADCSRA = (1<<ADEN)|(0<<ADATE);
	ADCSRA |= (0<<ADPS2)|(1<<ADPS1)|(1<<ADPS0);	// XTAL/8
    
   	while (1) {
		 ADCSRA |= (1<<ADSC);			// ADC Start Conversion
			while (!(ADCSRA &(1<<ADIF))){
			adc = ADCW;
			if(adc>=1024){
				adc=1024;}
		if((adc>=0)&&(adc<=20)){
		c=c+1;
		OCR0 = 1;
		OCR1A = 1;
		OCR2 = 1;
		if(c==100000){
		a++;
		zero();
		c=0;		
		}
		}
/***************** step color ***********************/	
		if(adc>20){
		c=0;}
		if((adc>=21)&&(adc<=49)){
		r=72;g=100;b=34;
		OCR0 = r;
		OCR1A = g;
		OCR2 = b;
		
		}
		if((adc>=50)&&(adc<=100)){
		r=113;g=182;b=1;
		OCR0 = r;
		OCR1A = g;
		OCR2 = b;
		
		}
		if((adc>=101)&&(adc<=419)){
		r=1;g=255;b=1;
		OCR0 = r;
		OCR1A = g;
		OCR2 = b;
		
		}
		if((adc>=420)&&(adc<=749)){
		r=1;g=1;b=255;
		OCR0 = r;
		OCR1A = g;
		OCR2 = b;
		
		}
		if((adc>=750)&&(adc<=1024)){
		r=255;g=1;b=1;
		OCR0 = r;
		OCR1A = g;
		OCR2 = b;
		
		}
		}	
		
	}

    return 0;
}            
/*************************************************** T/C0 Overflow Interrupt */
ISR (TIMER0_OVF_vect)
{  
  	;                       // Toggle PA0
    return;
}

/*************************************************** T/C0 Overflow Interrupt */
ISR (TIMER2_OVF_vect)
{  
  	;                       // Toggle PA0
    return;
}
/***************************************** Timer/Counter1 Overflow Interrupt */
ISR (TIMER1_OVF_vect)
{  
	;
    return;
}
